> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# List Product Variant Metafields

GET https://api.bigcommerce.com/stores/{store_hash}/v3/catalog/products/{product_id}/variants/{variant_id}/metafields

Returns a list of product variant *Metafields*. Optional parameters can be passed in.

Reference: https://docs.bigcommerce.com/developer/api-reference/rest/admin/catalog/product-variants/metafields/get-product-variant-metafields

## Authentication

- `X-Auth-Token` header (required) — ### OAuth scopes | UI Name | Permission | Parameter | |:--------|:-----------|:----------| | Products | modify | `store_v2_products` | | Products | read-only | `store_v2_products_read_only` | ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

## Request

### Path parameters

- `product_id` (integer, required) — The ID of the `Product` to which the resource belongs. Product variant metafield endpoints that have the `product_id` in the request path are successful as long as the parameter is not empty. The `product_id` segment is there only for path consistency.
- `variant_id` (integer, required) — ID of the variant on a product, or on an associated Price List Record.
- `store_hash` (string, required) — Permanent ID of the BigCommerce store.

### Query parameters

- `include_fields` (list of string, optional) — Fields to include, in a comma-separated list. The ID and the specified fields will be returned.
- `exclude_fields` (list of string, optional) — Fields to exclude, in a comma-separated list. The specified fields will be excluded from a response. The ID cannot be excluded.
- `page` (integer, optional) — Specifies the page number in a limited (paginated) list of products.
- `limit` (integer, optional) — Controls the number of items per page in a limited (paginated) list of products.
- `key` (string, optional) — Filter based on a metafieldʼs key.
- `namespace` (string, optional) — Filter based on a metafieldʼs namespaces.
- `resource_id:in` (string, optional) — A comma-separated list of entity ID values that filter results to metafields that belong to one of the matching entities.

### Headers

- `Accept` (string, required, default: application/json) — The [MIME type](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types) of the response body.

## Response

### 200

OK

- `data` (list of metafield_Full, optional)
- `meta` (categoriesTree_Resp, optional) — Returns the categories tree, a nested lineage of the categories with parent->child relationship. The Category objects returned are simplified versions of the category objects returned in the rest of this API.

## Types

### metafield_Full

- `key` (string, required) — The name of the field, for example: `location_id`, `color`. Required for POST.
- `namespace` (string, required) — Namespace for the metafield, for organizational purposes. This is set by the developer. Required for POST.
- `permission_set` (enum, required) — Determines the visibility and writeability of the field by other API consumers. |Value|Description |-|-| |`app_only`|Private to the app that owns the field| |`read`|Visible to other API consumers| |`write`|Open for reading and writing by other API consumers| |`read_and_sf_access`|Visible to other API consumers, including on storefront| |`write_and_sf_access`|Open for reading and writing by other API consumers, including on storefront|
  - Allowed values: `app_only`, `read`, `write`, `read_and_sf_access`, `write_and_sf_access`
- `value` (string, required) — The value of the field, for example: `1`, `blue`. You must enter a JSON formatted string for [ShipperHQ](/developer/docs/admin/store-configuration/shipping/shipper-hq#shipperhq-object-properties) metafields. Required for POST.
- `date_created` (datetime, optional) — Date and time of the metafieldʼs creation. Read-Only.
- `date_modified` (datetime, optional) — Date and time when the metafield was last updated. Read-Only.
- `description` (string, optional) — Description for the metafields.
- `id` (integer, optional) — Unique ID of the *Metafield*. Read-Only.
- `resource_id` (integer, optional) — The ID of the resource with which the metafield is associated.
- `resource_type` (enum, optional) — The type of resource with which the metafield is associated.
  - Allowed values: `category`, `brand`, `product`, `variant`

### categoriesTree_Resp

Returns the categories tree, a nested lineage of the categories with parent->child relationship. The Category objects returned are simplified versions of the category objects returned in the rest of this API.

- `data` (list of categoriesTreeNode_Full, optional)
- `meta` (metaEmpty_Full, optional) — Response metadata.

### categoriesTreeNode_Full

Used to reflect parent \<> child category relationships. Used by Category Tree.

- `id` (integer, optional) — The unique numeric ID of the category; increments sequentially.
- `parent_id` (integer, optional) — The unique numeric ID of the categoryʼs parent. This field controls where the category sits in the tree of categories that organize the catalog.
- `name` (string, optional) — The name displayed for the category. Name is unique with respect to the categoryʼs siblings.
- `is_visible` (boolean, optional) — Flag to determine whether the product should be displayed to customers browsing the store. If `true`, the category will be displayed. If `false`, the category will be hidden from view.
- `url` (string, optional) — The custom URL for the category on the storefront.

### metaEmpty_Full

Response metadata.

## Examples

**Response**

```json
{
  "data": [
    {
      "key": "Location",
      "namespace": "Warehouse Locations",
      "permission_set": "app_only",
      "value": "4HG",
      "date_created": "2018-05-07T20:14:17+00:00",
      "date_modified": "2018-05-07T20:14:17+00:00",
      "description": "Location in the warehouse",
      "id": 6,
      "resource_id": 111,
      "resource_type": "product"
    }
  ],
  "meta": {
    "data": [
      {
        "id": 26,
        "parent_id": 25,
        "name": "Bath",
        "is_visible": true,
        "url": "/towels/bath-towels/"
      }
    ],
    "meta": {}
  }
}
```

**SDK Code**

```python
import requests

url = "https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields"

querystring = {"resource_id:in":"15,16"}

headers = {
    "Accept": "application/json",
    "X-Auth-Token": "<apiKey>"
}

response = requests.get(url, headers=headers, params=querystring)

print(response.json())
```

```javascript
const url = 'https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields?resource_id%3Ain=15%2C16';
const options = {
  method: 'GET',
  headers: {Accept: 'application/json', 'X-Auth-Token': '<apiKey>'}
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields?resource_id%3Ain=15%2C16"

	req, _ := http.NewRequest("GET", url, nil)

	req.Header.Add("Accept", "application/json")
	req.Header.Add("X-Auth-Token", "<apiKey>")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields?resource_id%3Ain=15%2C16")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Accept"] = 'application/json'
request["X-Auth-Token"] = '<apiKey>'

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields?resource_id%3Ain=15%2C16")
  .header("Accept", "application/json")
  .header("X-Auth-Token", "<apiKey>")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields?resource_id%3Ain=15%2C16', [
  'headers' => [
    'Accept' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields?resource_id%3Ain=15%2C16");
var request = new RestRequest(Method.GET);
request.AddHeader("Accept", "application/json");
request.AddHeader("X-Auth-Token", "<apiKey>");
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Accept": "application/json",
  "X-Auth-Token": "<apiKey>"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.bigcommerce.com/stores/store_hash/v3/catalog/products/1/variants/1/metafields?resource_id%3Ain=15%2C16")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```